#include <stdlib.h>
#include <stdio.h>
#include "bmp.h"

FILE		*sfopen(char *filename)
{
  FILE		*res;

  res = fopen(filename, "rb");
  if (!res)
    {
      printf("error: can't open file %s\n", filename);
      exit(1);
    }
  return (res);
}

char		check_format(FILE *fd)
{
  char		c;

  if ((c = fgetc(fd)) == 'B')
    if ((c = fgetc(fd)) == 'M')
      return (1);
  printf("error: wrong BMP format\n");
  exit(1);
}

t_bitmap	*load_bmp(char *filename)
{
  FILE		*fd;
  int		line, x;
  int		R, G, B;
  int		offset;
  t_bitmap	*res;
  
  unsigned char Y, Cb, Cr;

  fd = sfopen(filename);
  check_format(fd);
  fseek(fd, 18, SEEK_SET);
  res = (t_bitmap *) malloc(sizeof(t_bitmap));
  fread(&(res->size_x), 4, 1, fd);
  fread(&(res->size_y), 4, 1, fd);
  res->data = (int *) malloc(sizeof(int) * res->size_x * res->size_y);
  offset = res->size_x * res->size_y - 1;
  fseek(fd, 54, SEEK_SET);
  for (line = res->size_y - 1; line >= 0; line--)
    for (x = 0; x < res->size_x; x++)
      {
	B = fgetc(fd);
	G = fgetc(fd);
	R = fgetc(fd);
	
	Y  = 0.29900 * R + 0.58700 * G + 0.11400 * B;
    Cb = -0.16874* R - 0.33126 * G + 0.50000 * B + 0x80;
    Cr = 0.50000 * R - 0.41869 * G - 0.08131 * B + 0x80;
   
	res->data[offset--] = (unsigned int) (Y << 24) | (Cb << 16) | (Y << 8) | Cr;
	//res->data[offset--] = (int) (B | G << 8 | R << 16);
	//res->data[offset--] = (int) (R | G << 8 | B << 16);
      }
  fclose(fd);
  return (res);
}

void	free_bmp(t_bitmap *b)
{
  free(b->data);
  free(b);
}
