#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

#include "bmp.h"

void	make_header(FILE *FD)
{
  fprintf(FD, "//\n// Made with Bmp2Gc by jeff@xgenus.com\n//\n\n");
}

void	make_data(FILE *FD, char *buf, t_bitmap *file)
{
  int len;
  int x, y;

  len = strlen(buf);
  buf[len-2] = 0;
  printf("Writing %s\n", buf);
  fprintf(FD, "const unsigned short int %s_x = %i;\n", buf, file->size_x);
  fprintf(FD, "const unsigned short int %s_y = %i;\n\n", buf, file->size_y);
  fprintf(FD, "const unsigned int %s[%i] = {\n", buf, file->size_x * file->size_y);
  for (y = 0; y < file->size_y; y++)
    {
      for (x = file->size_x; x > 0; x--)
	if (x == file->size_x)
	  fprintf(FD, "\t0x%.8x", file->data[x + file->size_x * y]);
	else
	  fprintf(FD, ", 0x%.8x", file->data[x + file->size_x * y]);
      if (y == file->size_y - 1)
	fprintf(FD, "\n");
      else
	fprintf(FD, ",\n");
    }
  fprintf(FD, "};\n\n");
}

int	main(int ac, char **av)
{
  t_bitmap *file;
  int i;
  char *buf;
  int len;
  FILE *FD;

  if (!av[1])
    {
      printf("Usage: %s file.bmp ...\n", av[0]);  
      return 0;
    }
  if (av[1][0] == '-' && av[1][1] == 'a')
    {
      printf("Making data.h\n");
      FD = fopen("data.h", "w+");
      make_header(FD);
      for (i = 2; i < ac; i++)
	{
	  buf = strdup(av[i]);
	  len = strlen(buf);
	  buf[len-3] = 'h';
	  buf[len-2] = 0;
	  printf("Loading %s\n", av[i]);    
	  file = load_bmp(av[i]);
	  make_data(FD, buf, file);
	  free_bmp(file);
	  free(buf);
	}
      fclose(FD);
    }
  else
    {
      for (i = 1; i < ac; i++)
	{
	  printf("Loading %s\n", av[i]);    
	  file = load_bmp(av[i]);    
	  buf = strdup(av[i]);
	  len = strlen(buf);
	  buf[len-3] = 'h';
	  buf[len-2] = 0;
	  FD = fopen(buf, "w+");
	  make_header(FD);
	  make_data(FD, buf, file);
	  fclose(FD);
	  free(buf);
	  free_bmp(file);
	}
    }
  printf("Done\n");
  return 0;
}
